// Climate.cpp: implementation of the CClimate class.
//
//////////////////////////////////////////////////////////////////////

#include "Climate.h"
#include "ClimateMidAtlantic.h"
#include "ClimateNAtlantic.h"
#include "ClimateSAtlantic.h"
#include "ClimateGulf.h"
#include "ClimateNPacific.h"
#include "Global.h"
#include <cstddef>

CClimate* CClimate::m_pInstance = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClimate::CClimate()
{

}

CClimate::~CClimate()
{

}

CClimate* CClimate::instance()
{
	if (!m_pInstance)
	{
		switch (CGlobal::getClimate())
		{
		case CClimate::MID_ATLANTIC:
			m_pInstance = CClimateMidAtlantic::instance();
			break;
		case CClimate::N_ATLANTIC:
			m_pInstance = CClimateNAtlantic::instance();
			break;
		case CClimate::S_ATLANTIC:
			m_pInstance = CClimateSAtlantic::instance();
			break;
		case CClimate::GULF:
			m_pInstance = CClimateGulf::instance();
			break;
		case CClimate::N_PACIFIC:
			m_pInstance = CClimateNPacific::instance();
			break;
		default:
			// error
			break;
		}
	}
	return m_pInstance;
}
