// ClimateNAtlantic.cpp: implementation of the CClimateNAtlantic class.
//
//////////////////////////////////////////////////////////////////////

#include <cstddef>

#include "ClimateNAtlantic.h"

int CClimateNAtlantic::m_nAveTemp[] = {10, 15, 25, 40, 55, 70, 85, 80, 60, 35, 20, 15};

int CClimateNAtlantic::m_nWeatherTable[12][4] = {
    {30,40,0,100}, /* January or the first month in non-Gregorian calendar */
    {25,35,0,100}, /* February */
    {20,30,0,100}, /* March */
    {35,50,0,100}, /* April */
    {25,40,0,100}, /* May */
    {15,25,26,100}, /* June */
    {10,15,16,100}, /* July */
    {10,15,16,100}, /* August */
    {15,30,31,100}, /* September */
    {25,40,0,100}, /* October */
    {25,40,0,100}, /* November */
    {30,45,0,100}  /* December */
};

int CClimateNAtlantic::m_nWindTable[12][5] = {
    {60,80,90,100,0},    /* January */
    {50,70,85,100,0},    /* February */  
    {40,60,75,95,100},   /* March */     
    {60,85,95,100,0},    /* April */     
    {70,90,100,0,0},     /* May */       
    {80,90,100,0,0},     /* June */      
    {80,100,0,0,0},      /* July */      
    {80,100,0,0,0},      /* August */    
    {60,80,95,100,0},    /* September */ 
    {40,65,85,95,100},   /* October */   
    {40,60,80,90,100},   /* November */  
    {60,80,90,95,100}    /* December */  
};

int CClimateNAtlantic::m_nPrecipTable[12][5] = {
    {0,40,70,80,100},   /* January */  
    {0,50,80,95,100},   /* February */ 
    {0,60,80,100,0},    /* March */    
    {0,40,70,90,100},   /* April */    
    {0,50,80,100,0},    /* May */      
    {0,60,90,100,0},    /* June */     
    {0,80,95,100,0},    /* July */     
    {0,80,95,100,0},    /* August */   
    {0,60,80,90,100},   /* September */
    {0,50,80,90,100},   /* October */  
    {0,40,70,85,100},   /* November */ 
    {0,40,70,80,100}    /* December */ 
};

int CClimateNAtlantic::m_nOvercastTable[] = {10,20,70,100};


CClimateNAtlantic* CClimateNAtlantic::m_pInstance = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClimateNAtlantic::CClimateNAtlantic()
{
}

CClimateNAtlantic::~CClimateNAtlantic()
{

}

int CClimateNAtlantic::getAveTemp(int nMonth)
{
	return m_nAveTemp[nMonth];
}

int CClimateNAtlantic::getWeather(int nMonth, int nTyp)
{
	return m_nWeatherTable[nMonth][nTyp];
}


int CClimateNAtlantic::getWind(int nMonth, int nTyp)
{
	return m_nWindTable[nMonth][nTyp];
}


int CClimateNAtlantic::getPrecip(int nMonth, int nTyp)
{
	return m_nPrecipTable[nMonth][nTyp];
}


int CClimateNAtlantic::getOvercast(int nTyp)
{
	return m_nOvercastTable[nTyp];
}

CClimateNAtlantic* CClimateNAtlantic::instance()
{
	if (!m_pInstance)
	{
		m_pInstance = new CClimateNAtlantic();
	}
	return m_pInstance;
}
